//###############################################################
//# mask1_slots.h for ProcessViewServer created: Di. Dez. 5 08:08:49 2023
//# please fill out these slots
//# here you find all possible events
//# Yours: Lehrig Software Engineering
//###############################################################

// todo: uncomment me if you want to use this data aquisiton
// also uncomment this classes in main.cpp and pvapp.h
// also remember to uncomment rllib in the project file
//extern rlModbusClient     modbus;  //Change if applicable
//extern rlSiemensTCPClient siemensTCP;
//extern rlPPIClient        ppi;
#include "rlspreadsheet.h"
#include "rlcutil.h"

extern char arg_pwd[];

typedef struct // (todo: define your data structure here)
{
  rlSpreadsheetRow row;
  int maxcol;
  int image1Context;
  int rotation;
  int running;
  char filepattern[80];
}
DATA;

int startDiashow(PARAM *p, DATA *d);

static int slotInit(PARAM *p, DATA *d)
{
  if(p == NULL || d == NULL) return -1;
  //memset(d,0,sizeof(DATA));
  pvPrintf(p,label1,pvtr("Dezember 2023: Opa's Diashow dir %s"), arg_pwd);

  d->running = 0;
  d->maxcol = 0;
  d->rotation = 0;
  d->image1Context = 1;
  strcpy(d->filepattern,"*.jpg");
  startDiashow(p, d);
  return 0;
}

static int slotNullEvent(PARAM *p, DATA *d)
{
  if(p == NULL || d == NULL) return -1;
  if(d->image1Context < d->maxcol && d->running)
  {
    ::printf("row.text(%d) =  %s\n", d->image1Context, d->row.text(d->image1Context));
    pvDownloadFileAs(p, d->row.text(d->image1Context), "image1.jpg");
    pvSetImage(p,image1,"image1.jpg",d->rotation);
    pvShow(p,image1);
    pvStatusMessage(p,0,255,0,"rotation=%d FILEPATTERN=%s file=%s", d->rotation, d->filepattern, d->row.text(d->image1Context));
    d->image1Context++;
  }    
  else
  {
    d->running = 0;
    pvStatusMessage(p,0,255,0,"rotation=%d FILEPATTERN=%s file=%s Finished", d->rotation, d->filepattern, d->row.text(d->image1Context - 1));
  }  
  return 0;
}

static int slotButtonEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  if(id == pbutton1)
  {
    ::printf("Start clicked\n");
    d->running = 1;
    int col = 1;
    int context = 0;
    const char *cret = rlFindFile(d->filepattern,&context);
    while(cret != NULL)
    {
      ::printf("%s\n", cret);
      d->row.setText(col++, cret);
      cret = rlFindFile(d->filepattern,&context);
    }
    if(strcmp(d->filepattern,"*.jpg") == 0)
    { // also search upper case files 
      context = 0;
      const char *cret = rlFindFile("*.JPG",&context);
      while(cret != NULL)
      {
        ::printf("%s\n", cret);
        d->row.setText(col++, cret);
        cret = rlFindFile("*.JPG",&context);
      }
    }  
    if(strcmp(d->filepattern,"*.png") == 0)
    { // also search upper case files 
      context = 0;
      const char *cret = rlFindFile("*.PNG",&context);
      while(cret != NULL)
      {
        ::printf("%s\n", cret);
        d->row.setText(col++, cret);
        cret = rlFindFile("*.PNG",&context);
      }
    }  
    d->maxcol = col;
    d->image1Context = 1;
    ::printf("#EndOfList\n");
  }
  else if(id == pbutton2)
  {
    d->rotation = 0;
  }
  else if(id == pbutton3)
  {
    d->rotation = -90;
  }
  else if(id == pbutton4)
  {
    d->rotation = 90;
  }
  else if(id == pbutton5)
  {
    d->rotation = 180;
  }
  else if(id == pbstop)
  {
    d->running = 0;
  }
  else if(id == pbforward && d->running == 0)
  {
    if(d->image1Context < d->maxcol) d->image1Context++;
    ::printf("Forward row.text(%d) =  %s\n", d->image1Context, d->row.text(d->image1Context));
    pvDownloadFileAs(p, d->row.text(d->image1Context), "image1.jpg");
    pvSetImage(p,image1,"image1.jpg",d->rotation);
    pvShow(p,image1);
    pvStatusMessage(p,0,255,0,"rotation=%d FILEPATTERN=%s file=%s", d->rotation, d->filepattern, d->row.text(d->image1Context));
  }
  else if(id == pbbackward && d->running == 0)
  {
    if(d->image1Context > 1) d->image1Context--;
    ::printf("Backward row.text(%d) =  %s\n", d->image1Context, d->row.text(d->image1Context));
    pvDownloadFileAs(p, d->row.text(d->image1Context), "image1.jpg");
    pvSetImage(p,image1,"image1.jpg",d->rotation);
    pvShow(p,image1);
    pvStatusMessage(p,0,255,0,"rotation=%d FILEPATTERN=%s file=%s", d->rotation, d->filepattern, d->row.text(d->image1Context));
  }
  else if(id == pbescape)
  {
    return 1;
  }
 
  return 0;
}

int startDiashow(PARAM *p, DATA *d)
{
  d->running = 1;
  return slotButtonEvent(p, pbutton1, d);
}

static int slotButtonPressedEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotButtonReleasedEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotTextEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  if(id == lineedit1)
  {
    if(strlen(text) < 80) 
    {
      strcpy(d->filepattern,text);
    }  
  }
  return 0;
}

static int slotSliderEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotCheckboxEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotRadioButtonEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotGlInitializeEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotGlPaintEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotGlResizeEvent(PARAM *p, int id, DATA *d, int width, int height)
{
  if(p == NULL || id == 0 || d == NULL || width < 0 || height < 0) return -1;
  return 0;
}

static int slotGlIdleEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotTabEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotTableTextEvent(PARAM *p, int id, DATA *d, int x, int y, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000 || text == NULL) return -1;
  return 0;
}

static int slotTableClickedEvent(PARAM *p, int id, DATA *d, int x, int y, int button)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000 || button < 0) return -1;
  return 0;
}

static int slotSelectionEvent(PARAM *p, int id, DATA *d, int val, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000 || text == NULL) return -1;
  return 0;
}

static int slotClipboardEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == -1 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotRightMouseEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  //pvPopupMenu(p,-1,"Menu1,Menu2,,Menu3");
  return 0;
}

static int slotKeyboardEvent(PARAM *p, int id, DATA *d, int val, int modifier)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000 || modifier < -1000) return -1;
  return 0;
}

static int slotMouseMovedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 0;
}

static int slotMousePressedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 0;
}

static int slotMouseReleasedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 0;
}

static int slotMouseOverEvent(PARAM *p, int id, DATA *d, int enter)
{
  if(p == NULL || id == 0 || d == NULL || enter < -1000) return -1;
  return 0;
}

static int slotUserEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}
